From cns.bu.edu!rjwood Thu Oct 23 23:49:31 1997
Return-Path: <rjwood@cns.bu.edu>
Received: from cns.bu.edu(CNS.BU.EDU[128.197.61.100]) (2406 bytes) by mail.chemie.fu-berlin.de
	via smail with P:smtp/D:user/T:local
	(sender: <rjwood@cns.bu.edu>) 
	id <m0xOV8D-000CDcC@mail.chemie.fu-berlin.de>
	for <clausi@chemie.fu-berlin.de>; Thu, 23 Oct 1997 23:49:29 +0200 (MET DST)
	(Smail-3.2.0.98 1997-Oct-16 #9 built 1997-Oct-23)
Received: from retina.bu.edu by cns.bu.edu (8.8.5/BU-11/2/94)
	id RAA19065; Thu, 23 Oct 1997 17:49:25 -0400 (EDT)
From: rjwood@cns.bu.edu (Richard Wood)
Received: by retina.bu.edu (8.6.13/BU_Client-1.1)
	id RAA17588; Thu, 23 Oct 1997 17:49:25 -0400
Date: Thu, 23 Oct 1997 17:49:25 -0400
Message-Id: <199710232149.RAA17588@retina.bu.edu>
To: clausi@chemie.fu-berlin.de
In-reply-to: <Pine.SGI.3.91.971023124135.13988C-100000@lynx.chemie.fu-berlin.de> (message from Claus Schroeter on Thu, 23 Oct 1997 12:43:05 +0200 (MEST))
Subject: Re: GPIB Timing?
Status: RO
X-Status: 


Hi Claus,

>>>>> "Claus" == Claus Schroeter <clausi@chemie.fu-berlin.de> writes:

    Claus> This sounds _very_ good, please let me know what changes
    Claus> you did exactly.  If you send me a diff file please take it
    Claus> with -u to see the context as well

Here's the diff:

--- wait.c.orig	Tue Oct 21 17:59:12 1997
+++ wait.c	Tue Oct 21 20:32:09 1997
@@ -1,4 +1,8 @@
 #include <board.h>
+#include <asm/io.h>
+
+/* #define REALLY_SLOW_IO */
+
 /* @BEGIN-MAN
 
 \routine{  bdwait(unsigned int mask)  }
@@ -23,8 +27,11 @@
 #if USEINTS
 	if (!(pgmstat & PS_NOINTS)) {
 		DBGprint(DBG_BRANCH, ("use ints  "));
+		SLOW_DOWN_IO;
 		s = GPIBin(isr1);           /* clear ISRs by reading */
+		SLOW_DOWN_IO;
 		s = GPIBin(isr2);
+		SLOW_DOWN_IO;
 		imr2mask = 0;
 		if (mask & SRQI)
 			imr2mask |= HR_SRQIE;
@@ -33,9 +40,13 @@
 		DBGprint(DBG_DATA, ("imr2mask=0x%x  ", imr2mask));
 		while (!(ibstat() & mask) && NotTimedOut()) {
 			ibsta = CMPL;
+			SLOW_DOWN_IO;
 			GPIBout(imr2, imr2mask);
+			SLOW_DOWN_IO;
 			osWaitForInt(HR_TLCI);
+			SLOW_DOWN_IO;
 			GPIBout(imr2, 0);   /* clear imr2 IE bits */
+			SLOW_DOWN_IO;
 			s = GPIBin(isr2);   /* clear isr2 status bits */
 			DBGprint(DBG_DATA, ("isr2=0x%x  ", s));
 		}
@@ -71,7 +82,12 @@
 {
 uint8 isreg1;
 DBGin("bdWaitIn");
-while (!((isreg1 = GPIBin(isr1)) & HR_DI) && NotTimedOut());
+SLOW_DOWN_IO;
+while (!((isreg1 = GPIBin(isr1)) & HR_DI) && NotTimedOut())
+  {
+    SLOW_DOWN_IO;
+  }
+
 DBGout();
 return isreg1;
 }
@@ -93,7 +109,11 @@
 bdWaitOut(void)
 {
 DBGin("bdWaitOut");
-while (!(GPIBin(isr2) & HR_CO) && NotTimedOut());
+SLOW_DOWN_IO;
+while (!(GPIBin(isr2) & HR_CO) && NotTimedOut())
+  {
+    SLOW_DOWN_IO;
+  }
 DBGout();
 }
 

